n, m, k = map(int, input().split())

# Чтение информации о дорогах
a = [tuple(map(int, input().split())) for _ in range(m)]

# Чтение информации об охранниках
ohrana = [tuple(map(int, input().split())) for _ in range(k)]

# Создание матрицы смежности
b = [[0] * n for _ in range(n)]
for u, v in a:
    b[u-1][v-1] = 1
    b[v-1][u-1] = 1

# Применение алгоритма Флойда-Уоршелла для нахождения минимальных расстояний
b = [[float('inf')] * n for _ in range(n)]
for i in range(n):
    b[i][i] = 0
for i in range(n):
    for j in range(n):
        if b[i][j]:
            b[i][j] = 1

for k in range(n):
    for i in range(n):
        for j in range(n):
            if b[i][k] < float('inf') and b[k][j] < float('inf'):
                b[i][j] = min(b[i][j], b[i][k] + b[k][j])

# Определение охраняемых складов
ohraned = set()
for p, h in ohrana:
    for i in range(n):
        if b[p-1][i] <= h:
            ohraned.add(i+1)

# Вывод результата
for warehouse in sorted(ohraned):
    print(warehouse)
